#!/usr/bin/env python3
# -*- coding: utf-8 -*- 

#-------------------------------------------------
# IMPORTS
#-------------------------------------------------
import logging
from datetime import datetime
from pathlib import Path
home = str(Path.home())

#-------------------------------------------------
# MODULES
#-------------------------------------------------

#
def initializeLog(os_sys,projectName):
        
    # path
    if os_sys == "Darwin":
        logPath = home + "/Library/Logs/" + projectName + "/"
    elif os_sys == "Windows":
        logPath = home + "\AppData\Local\\" + projectName + "\\"
    
    # write log
    Path(logPath).mkdir(parents=True, exist_ok=True)
    logging.basicConfig(filename=logPath + "main-log.log", 
        encoding='utf-8',
        level=logging.INFO,
        format='%(asctime)s - %(message)s',
        datefmt='%d/%m/%Y %I:%M:%S')
    
    # header
    logging.info(''.join(['-'*80]))
    logging.info("App launched at: " + str(datetime.now()))

    # return logPath
    return logPath

#
def logMsg(level,msg):
    logging.info(level + "=" + msg)

#
def logVar(name,value):
    logging.info(name + "=" + str(value))

#
def logFunction(func, *args):
    try:
        func(*args)
    #capture stderr
    except Exception as e:
        logging.critical(e, exc_info=True)
