#!/usr/bin/env python3
# -*- coding: utf-8 -*- 

#-------------------------------------------------
# IMPORTS
#-------------------------------------------------

from PyQt5.QtCore import QObject, pyqtSignal
from time import sleep
import csv
import os

from common.logger import logMsg

#-------------------------------------------------
# MODULES
#-------------------------------------------------

class Worker3(QObject):
    
    # signals
    sig_progress = pyqtSignal(int)
    sig_maxProgress = pyqtSignal(int)
    sig_workerEnd = pyqtSignal()

    #
    def __init__(self, renameUniqueFilePath, parent=None):
        QObject.__init__(self, parent)
        
        # attributes
        self.renameUniqueFilePath = renameUniqueFilePath

    # Search for forbidden characters
    def renaming(self):

        # set sigs
        self.sig_progress.emit(0)
        self.sig_maxProgress.emit(0)
        
        # log
        logMsg("INFO", "Renaming START")

        # sleep to make it slow - userfriendly
        sleep(0.5)

        # read indexFile, append renameFile
        self.renameUniqueFile = open(self.renameUniqueFilePath, "r")

        # read index and send nb of lines
        lines = self.renameUniqueFile.readlines()
        self.sig_maxProgress.emit(len(lines))

        #Renaming loop with count
        self.count = 0
        for line in csv.reader(lines, delimiter='\t'):
            os.rename(line[0], line[1])
            self.count+=1
            self.sig_progress.emit(self.count)

        #log
        logMsg("INFO", "Renaming completed: " + str(self.count) + " files renamed.")

        # close files
        self.renameUniqueFile.close()

        # sleep to make it slow - userfriendly
        sleep(0.5)

        # log
        logMsg("INFO", "renaming END")

        # end sig
        self.sig_progress.emit(1)
        self.sig_maxProgress.emit(1)
        self.sig_workerEnd.emit()
 